#include <stdio.h>
#include <stdlib.h>
#include <math.h>

long long int x = 0,c,n,m,i,j;
long int a[20000001],b[100001];

int main()
{
    scanf("%lli%lli",&n,&m);

    for(i = 1;i <= n;i++)
        a[i] = i;

    for(i = 1;i <= m;i++)
        scanf("%li",&b[i]);

    scanf("%lli",&c);

    for(i = 0;i <= n - m;i++)
    {
        for(j = 1;j <= m;j++){
            a[i + b[j]] = a[i + j];
        }
    }

    for(i = 1; i <= n;i++)
        x += pow(c,i) * a[i];

    printf("%lli",x);

    return 0;
}